<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 12.04.01 - Build 01.04.2012
 * Lizenziert unter 'Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)'
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
error_reporting(E_ALL);
	if ( version_compare(PHP_VERSION,'5.0.0','<') )
	trigger_error('"WADE" benötigt mindestens PHP-Version 5',E_USER_ERROR);
	if ( !extension_loaded('pcre') )
	trigger_error('"WADE" benötigt Perl-kompatible reguläre Ausdrücke (PCRE)',E_USER_ERROR);
	if ( !isset($argc) || !isset($argv) )
	trigger_error('"WADE" läuft nur auf einer Kommandozeile/Shell/Eingabeaufforderung (CLI)',E_USER_ERROR);
setlocale(LC_TIME,'de_DE.utf8');
date_default_timezone_set('Europe/Berlin');
define('WADE_VERSION_STRING','12.04.01');
require_once('./wade.konfiguration.php');
require_once('./wade.funktionen.php');
echo "**********************************************************\n";
echo "**   W E T T E R - A N A L Y S E   I N   D E K A D E N  **\n";
echo "**********************************************************\n";
echo "** Berechnung der Dekadenwerte von Wetterstationen      **\n";
echo "**     Vergleichen von Jahren zu Referenzzeiträumen     **\n";
echo "**        Ermittlung von Rekorden in Referenzzeiträumen **\n";
echo "**------------------------------------------------------**\n";
echo "** ## Von 'Trixi aus Witten/NRW'                     ## **\n";
echo "** ## http://taw-wade.kilu.de/                       ## **\n";
echo "**********************************************************\n";
echo "\n";
	if ( $argc < 2 || in_array(strtolower($argv[1]),array('-h','--help','-help','/h','/help','/?'),true) ){
	$php_pfad = ( isset($_SERVER['_']) ) ? realpath($_SERVER['_']) : 'Unbekannt oder CGI';
	echo "PHP-Programm: ".$php_pfad." (Version ".PHP_VERSION."/".PHP_OS.")\n";
	echo "WADE-Version: ".WADE_VERSION_STRING."\n";
	echo "Aktueller WADE-Pfad: ".dirname(__FILE__)."\n";
	echo "Zwischenspeicher: ".$einstellungen['zwischenspeicher']['speicher_pfad']."\n\n";
	echo "Folgende Aktionen kann 'WADE' ausführen:\n";
	echo "--import\t\tHolt die Wetter-Rohdaten einer Station und lädt\n";
	echo "\t\t\tsie in den lokalen Zwischenspeicher\n";
	echo "--export\t\tZeichnet die Vektorgrafik einer Station\n";
	echo "--wieselflink\t\tZählt für jede Dekade die Tage an denen eine\n";
	echo "\t\t\tBedingung zutrifft\n";
	echo "--rekorde\t\tBerechnet für jede Dekade die Dekadenrekorde und\n";
	echo "\t\t\tabsolute einzelner Tage\n";
	echo "--hitliste\t\tErmittelt eine Rangliste nach sortiert Jahren bei\n";
	echo "\t\t\tdenen die Bedingungen zutreffen\n";
	echo "--liste\t\t\tListet alle verfügbaren Stationen und den\n";
	echo "\t\t\tInhalt des lokalen Zwischenspeichers auf\n";
	echo "--update\t\tPrüft online, ob eine neue WADE-Version vorhanden ist\n";
	echo "--help\t\t\tDiese zauberhaften Hilfe-Anweisungen\n";
	echo "-v\t\t\tErhöht die Redseligkeit. Je mehr 'v', desto\n";
	echo "\t\t\tgeschwätziger ;)\n\n";
	echo "Folgende Argumente können oder müssen angegeben werden:\n";
	echo "--konfiguration=[datei]\tPfad zur benutzerdefinierten Konfiguration\n";
	echo "\t\t\tStandardmäßig die 'benutzer_konfiguration.ini' im aktuellen WADE-Pfad\n";
	echo "--station=[name]\tDer Name der Station\n";
	echo "--jahr=[name]\t\tDas zu verwendene Jahr für die Grafik (nur export)\n";
	echo "--vergleich=[jahre]\tDie Jahre für den Vergleichszeitraum (nur export,wieselflink,rekorde,hitliste)\n";
	echo "\t\t\t\tMehrere Jahre mit Komma trennen oder eine Spanne mit - angeben\n";
	echo "\t\t\t\tDas Sternchen '*' wählt alle für die Station verfügbaren Jahre\n";
	echo "\t\t\t\tBeispiele: 1920-1980 2000,2001,2002 1980-1985,1990-1995,1997\n";
	echo "--typ=[typ]\t\tDer Ausgabetyp eines Reports (nur wieselflink,rekorde,hitliste)\n";
	echo "\t\t\t\to 'roh' => Als roher Datensatz\n";
	echo "\t\t\t\to 'text' => Als einfache Textdatei (Standard)\n";
	echo "\t\t\t\to 'html' => Als HTML-Datei für das Internet\n";
	echo "\t\t\t\to 'xml' => Als XML-Datei zum Datenaustausch\n";
	echo "--typ=[typ]\t\tDie Datenbasis des Diagramms (nur export)\n";
	echo "\t\t\t\to 'abweichung' => Abweichungen vom Klimamittel (Standard)\n";
	echo "\t\t\t\to 'mittel' => Die Klimamittelwerte des Vergleichzeitraums\n";
	echo "\t\t\t\to 'absolut' => Die absoluten Werte des gewählten Jahres\n";
	echo "--bedingung=[...]\tFormuliert die Bedingung (nur wieselflink)\n";
	echo "\t\t\t\tBeispiele: 'temperatur_max >= 25', 'niederschlag > 0'\n";
	}
$DA = new Dekaden_Analyse();
$DA->KonsolenAusgabe(print_r($DA->cli_parameter,true),3);
	if ( isset($DA->cli_parameter['aktion']) && strlen($DA->cli_parameter['aktion']) > 0 )
	require_once('./wade.aktion.'.$DA->cli_parameter['aktion'].'.php');
?>
