<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 12.04.01 - Build 01.04.2012
 * Lizenziert unter 'Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)'
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
$DA->KonsolenAusgabe('Beginn der Datenverarbeitung',1);
	if ( !is_dir($einstellungen['zwischenspeicher']['speicher_pfad']) )
	$DA->KonsolenAusgabe('Das Verzeichnis für den Zwischenspeicher existiert nicht',-1);
	if ( strlen($DA->cli_parameter['station']) < 4 )
	$DA->KonsolenAusgabe('Es wurde keine Station mit "--station=[name]" angegeben',-1);
	if ( !isset($einstellungen['daten'][$DA->cli_parameter['station']]) )
	$DA->KonsolenAusgabe('Diese Station befindet sich nicht in der Konfiguration',-1);
	if ( $DA->cli_parameter['vergleich'] === '' )
	$DA->KonsolenAusgabe('Es wurde kein Vergleichszeitraum mit "--vergleich=[jahre]" angegeben',-1);
	if ( $DA->cli_parameter['bedingung'] === '' )
	$DA->KonsolenAusgabe('Es wurde keine Bedingung mit --bedingung angegeben',-1);

preg_match('/^([a-z_]+)\s+([<>=]{1,2})\s+([0-9\-]+)$/uiD',$DA->cli_parameter['bedingung'],$bedingungen);
	if ( !is_array($bedingungen) || sizeof($bedingungen) !== 4 )
	$DA->KonsolenAusgabe('Es wurde keine gültige Bedingung angegeben',-1);
	if ( !in_array($bedingungen[1],$DA->datenreihen,true) )
	$DA->KonsolenAusgabe('Die gewählte Datenreihe in der Bedingung existiert nicht',-1);

$datensatz = $DA->HoleRoheDatenDerJahre($DA->cli_parameter['station'],$DA->cli_parameter['vergleich']);
$ergebnis = array();
$jahre = array();
$gesamt = array();

$DA->KonsolenAusgabe('Suche nach Tagen auf die gewählte Bedingung zutrifft',2);

	foreach ( $DA->grundgeruest_dekaden as $dekade=>$werte )
	$ergebnis[$dekade] = array();

	foreach ( $datensatz as $daten ){
	$dekade = $DA->ErmittleDekade($daten['tag']);
	$schluessel = $daten['monat'].'/'.$dekade;
		if ( !isset($ergebnis[$schluessel][$daten['jahr']]) )
		$ergebnis[$schluessel][$daten['jahr']] = 0;
		if ( !in_array($daten['jahr'],$jahre,true) )
		$jahre[] = $daten['jahr'];
		if ( !isset($gesamt[$daten['jahr']]) )
		$gesamt[$daten['jahr']] = 0;
		switch ( $bedingungen[2] ){
		case '<':
			if ( $daten[$bedingungen[1]] < doubleval($bedingungen[3]) ){
			$ergebnis[$schluessel][$daten['jahr']]++;
			$gesamt[$daten['jahr']]++;
			}
		break;
		case '<=':
			if ( $daten[$bedingungen[1]] <= doubleval($bedingungen[3]) ){
			$ergebnis[$schluessel][$daten['jahr']]++;
			$gesamt[$daten['jahr']]++;
			}
		break;
		case '>=':
			if ( $daten[$bedingungen[1]] >= doubleval($bedingungen[3]) ){
			$ergebnis[$schluessel][$daten['jahr']]++;
			$gesamt[$daten['jahr']]++;
			}
		break;
		case '>':
			if ( $daten[$bedingungen[1]] > doubleval($bedingungen[3]) ){
			$ergebnis[$schluessel][$daten['jahr']]++;
			$gesamt[$daten['jahr']]++;
			}
		break;
		case '=':
			if ( $daten[$bedingungen[1]] == doubleval($bedingungen[3]) ){
			$ergebnis[$schluessel][$daten['jahr']]++;
			$gesamt[$daten['jahr']]++;
			}
		break;
		}
	}

	if ( $einstellungen['wieselflink']['ergebnis_sortieren'] === 'aufsteigend' ){
	asort($gesamt);
	$jahre = array_keys($gesamt);
	}
	elseif ( $einstellungen['wieselflink']['ergebnis_sortieren'] === 'absteigend' ){
	arsort($gesamt);
	$jahre = array_keys($gesamt);
	}

$DA->KonsolenAusgabe('Datenbearbeitung beendet',1);

$DA->KonsolenAusgabe('Erstellen des Reports vom Typ '.$DA->cli_parameter['typ'],1);
$DA->KonsolenAusgabe('Die Dekaden folgender Monate wurden ausgewählt '.$einstellungen['wieselflink']['monate_anzeigen'],1);
$monate_anzeigen = explode(',',$einstellungen['wieselflink']['monate_anzeigen']);
define('LF',"\r\n"); // \r\n für bessere Lesbarkeit unter Windows beim Standardeditor
$gesamt_y = array();
$report = '';

	switch ( $DA->cli_parameter['typ'] ){
	case 'text':
	$report .= str_repeat('=',72).LF;
	$report .= 'GEFUNDENE TAGE IM ZEITRAUM '.$DA->cli_parameter['vergleich'].LF;
	$report .= 'Erstellt am '.date('r').LF;
	$report .= 'Name der Station: '.$einstellungen['daten'][$DA->cli_parameter['station']]['name'].
		' ('.$einstellungen['daten'][$DA->cli_parameter['station']]['code'].')'.LF;
	$report .= 'Daten-Quelle: '.$einstellungen['daten'][$DA->cli_parameter['station']]['quelle'].LF;
	$report .= 'Bedingung: '.$DA->cli_parameter['bedingung'].LF.LF;
		if ( !empty($einstellungen['wieselflink']['kommentar']) )
		$report .= $einstellungen['wieselflink']['kommentar'].LF.LF;
	$report .= '        ';

		foreach ( $DA->grundgeruest_dekaden as $dekade=>$werte ){
		$monat = substr($dekade,0,strpos($dekade,'/'));
			if ( !in_array($monat,$monate_anzeigen) )
			continue;
			if ( !isset($gesamt_y[$dekade]) )
			$gesamt_y[$dekade] = 0;
		$dekade_string = explode(chr(10),$DA->DekadeNachString($dekade,'%B'));
		$report .= ucfirst(substr($dekade_string[0],0,1)).'.'.$dekade_string[1].' ';
		}
		if ( $einstellungen['wieselflink']['gesamt_werte_anzeigen'] )
		$report .= '   GESAMT';
	$report .= LF.LF;

		foreach ( $jahre as $jahr ){
		$gesamt_x = 0;
		$puffer = '';
		$puffer .= $jahr.'    ';
			foreach ( $DA->grundgeruest_dekaden as $dekade=>$werte ){
			$monat = substr($dekade,0,strpos($dekade,'/'));
				if ( !in_array($monat,$monate_anzeigen) )
				continue;
			$wert = ( isset($ergebnis[$dekade][$jahr]) ) ? $ergebnis[$dekade][$jahr] : '-';
				if ( is_numeric($wert) ){
				$gesamt_x += $wert;
				$gesamt_y[$dekade] += $wert;
				}
				if ( $einstellungen['wieselflink']['nullen_entfernen'] && $wert === 0 )
				$puffer .= '    ';
				else
				$puffer .= sprintf('% 3s ',$wert);
			}
			if ( $einstellungen['wieselflink']['gesamt_werte_anzeigen'] )
			$puffer .= '   '.$gesamt_x;
			if ( $gesamt_x === 0 && $einstellungen['wieselflink']['leere_jahre_weglassen'] )
			continue;
		$report .= $puffer.LF;
		}

		if ( $einstellungen['wieselflink']['gesamt_werte_anzeigen'] ){
		$report .= LF.'GESAMT  ';
			foreach ( $DA->grundgeruest_dekaden as $dekade=>$werte ){
			$monat = substr($dekade,0,strpos($dekade,'/'));
				if ( !in_array($monat,$monate_anzeigen) )
				continue;
			$report .= sprintf('% 3d ',$gesamt_y[$dekade]);
			}
		$report .= '   '.array_sum($gesamt_y);
		}

	break;
	case 'html':
	$report .= '<!DOCTYPE html>'.LF;
	$report .= '<html>'.LF;
	$report .= '<head>'.LF;
	$report .= '<meta http-equiv="content-type" content="text/html;charset=utf-8" />'.LF;
	$report .= '<style type="text/css">td { text-align: right; } .kopf { font-weight: bold; }
		.hell { background-color: #ccc; } .dunkel { background-color: #aaa; }
		.hell:hover, .dunkel:hover { background-color: #ffa; }</style>'.LF;
	$report .= '</head>'.LF;
	$report .= '<body>'.LF;
	$report .= '<h2>GEFUNDENE TAGE IM ZEITRAUM '.$DA->cli_parameter['vergleich'].'</h2>'.LF;
	$report .= '<p>Erstellt am '.date('r').'<br />'.LF;
	$report .= 'Name der Station: '.$einstellungen['daten'][$DA->cli_parameter['station']]['name'].
		' ('.$einstellungen['daten'][$DA->cli_parameter['station']]['code'].')<br />'.LF;
	$report .= 'Daten-Quelle: '.$einstellungen['daten'][$DA->cli_parameter['station']]['quelle'].'<br />'.LF;
	$report .= 'Bedingung: '.$DA->cli_parameter['bedingung'].'</p>'.LF;
		if ( !empty($einstellungen['wieselflink']['kommentar']) )
		$report .= '<p>'.$einstellungen['wieselflink']['kommentar'].'</p>'.LF;
	$report .= '<table>'.LF;
	$report .= '<tr class="kopf">'.LF;
	$report .= '<td>&nbsp;</td>'.LF;

		foreach ( $DA->grundgeruest_dekaden as $dekade=>$werte ){
		$monat = substr($dekade,0,strpos($dekade,'/'));
			if ( !in_array($monat,$monate_anzeigen) )
			continue;
			if ( !isset($gesamt_y[$dekade]) )
			$gesamt_y[$dekade] = 0;
		$dekade_string = explode(chr(10),$DA->DekadeNachString($dekade,'%B'));
		$report .= '<td>'.ucfirst(substr($dekade_string[0],0,1)).'.'.$dekade_string[1].'</td>'.LF;
		}
		if ( $einstellungen['wieselflink']['gesamt_werte_anzeigen'] )
		$report .= '<td>GESAMT</td>'.LF;
	$report .= '</tr>'.LF;
	$farbe = 'hell';

		foreach ( $jahre as $jahr ){
		$gesamt_x = 0;
		$puffer = '<tr class="'.$farbe.'">'.LF;
			if ( $farbe === 'hell' )
			$farbe = 'dunkel';
			elseif ( $farbe === 'dunkel' )
			$farbe = 'hell';
		$puffer .= '<td>'.$jahr.'</td>'.LF;
			foreach ( $DA->grundgeruest_dekaden as $dekade=>$werte ){
			$monat = substr($dekade,0,strpos($dekade,'/'));
				if ( !in_array($monat,$monate_anzeigen) )
				continue;
			$wert = ( isset($ergebnis[$dekade][$jahr]) ) ? $ergebnis[$dekade][$jahr] : '-';
				if ( is_numeric($wert) ){
				$gesamt_x += $wert;
				$gesamt_y[$dekade] += $wert;
				}
				if ( $einstellungen['wieselflink']['nullen_entfernen'] && $wert === 0 )
				$puffer .= '<td>&nbsp;</td>'.LF;
				else
				$puffer .= '<td>'.$wert.'</td>'.LF;
			}
			if ( $einstellungen['wieselflink']['gesamt_werte_anzeigen'] )
			$puffer .= '<td>'.$gesamt_x.'</td>'.LF;
			if ( $gesamt_x === 0 && $einstellungen['wieselflink']['leere_jahre_weglassen'] )
			continue;
		$puffer .= '</tr>'.LF;
		$report .= $puffer.LF;
		}

		if ( $einstellungen['wieselflink']['gesamt_werte_anzeigen'] ){
		$report .= LF.'<tr><td><strong>GESAMT</strong></td>'.LF;
			foreach ( $DA->grundgeruest_dekaden as $dekade=>$werte ){
			$monat = substr($dekade,0,strpos($dekade,'/'));
				if ( !in_array($monat,$monate_anzeigen) )
				continue;
			$report .= '<td>'.$gesamt_y[$dekade].'</td>'.LF;
			}
		$report .= '<td>'.array_sum($gesamt_y).'</td>'.LF;
		$report .= '</tr>'.LF;
		}

	$report .= '</table>'.LF;
	$report .= '</body>'.LF;
	$report .= '</html>';
	break;
	case 'xml':
	$report .= '<?xml version="1.0" encoding="utf-8" standalone="yes"?>'.LF;
	$report .= '<wieselflink>'.LF;
		if ( !empty($einstellungen['wieselflink']['kommentar']) )
		$report .= '/* '.$einstellungen['wieselflink']['kommentar'].' */'.LF;
	$report .= '<meta>'.LF;
	$report .= chr(9).'<erstelltam>'.date('r').'</erstelltam>'.LF;
	$report .= chr(9).'<zeitraum>'.$DA->cli_parameter['vergleich'].'</zeitraum>'.LF;
	$report .= chr(9).'<name>'.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['name']).'</name>'.LF;
	$report .= chr(9).'<code>'.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['code']).'</code>'.LF;
	$report .= chr(9).'<datenquelle>'.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['quelle']).'</datenquelle>'.LF;
	$report .= chr(9).'<bedingung>'.htmlspecialchars($DA->cli_parameter['bedingung']).'</bedingung>'.LF;
	$report .= '</meta>'.LF;
	$report .= '<daten>'.LF;

		foreach ( $jahre as $jahr ){
		$gesamt_x = 0;
		$puffer = '';
		$report .= chr(9).'<datensatz>'.LF;
		$report .= chr(9).chr(9).'<jahr>'.$jahr.'</jahr>'.LF;
			foreach ( $DA->grundgeruest_dekaden as $dekade=>$werte ){
			$monat = substr($dekade,0,strpos($dekade,'/'));
				if ( !in_array($monat,$monate_anzeigen) )
				continue;
				if ( !isset($gesamt_y[$dekade]) )
				$gesamt_y[$dekade] = 0;
			$dekade_string = explode(chr(10),$DA->DekadeNachString($dekade,'%m'));
			$wert = ( isset($ergebnis[$dekade][$jahr]) ) ? $ergebnis[$dekade][$jahr] : '-';
				if ( is_numeric($wert) ){
				$gesamt_x += $wert;
				$gesamt_y[$dekade] += $wert;
				}
				if ( $einstellungen['wieselflink']['nullen_entfernen'] && $wert === 0 )
				$puffer .= '';
				else
				$puffer .= chr(9).chr(9).'<dekade id="'.implode('/',$dekade_string).'">'.$wert.'</dekade>'.LF;
			}
			if ( $einstellungen['wieselflink']['gesamt_werte_anzeigen'] )
			$puffer .= chr(9).chr(9).'<gesamt>'.$gesamt_x.'</gesamt>'.LF;
			if ( $gesamt_x === 0 && $einstellungen['wieselflink']['leere_jahre_weglassen'] )
			continue;
		$report .= $puffer;
		$report .= chr(9).'</datensatz>'.LF;
		}

		if ( $einstellungen['wieselflink']['gesamt_werte_anzeigen'] ){
		$report .= chr(9).'<datensatz_gesamt>'.LF;
			foreach ( $DA->grundgeruest_dekaden as $dekade=>$werte ){
			$monat = substr($dekade,0,strpos($dekade,'/'));
				if ( !in_array($monat,$monate_anzeigen) )
				continue;
			$dekade_string = explode(chr(10),$DA->DekadeNachString($dekade,'%m'));
			$report .= chr(9).chr(9).'<dekade id="'.implode('/',$dekade_string).'">'.$gesamt_y[$dekade].'</dekade>'.LF;
			}
		$report .= chr(9).chr(9).'<gesamt>'.array_sum($gesamt_y).'</gesamt>'.LF;
		$report .= chr(9).'</datensatz_gesamt>'.LF;
		}

	$report .= '</daten>';
	$report .= '</wieselflink>';
	break;
	default:
	$report = print_r($ergebnis,true);
	break;
	}

	if ( !empty($einstellungen['report']['ausgabe_datei_maske']) && is_writeable(dirname($einstellungen['report']['ausgabe_datei_maske'])) )
	file_put_contents($einstellungen['report']['ausgabe_datei_maske'],$report);
$DA->KonsolenAusgabe('Report erstellt in "'.$einstellungen['report']['ausgabe_datei_maske'].'"',1);
$DA->KonsolenAusgabe('Aufgaben erledigt. Ciao!',0);

?>
